<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      min-label-width="68px"
    >
      <el-form-item :label="t('EquipmentManagement.EquipmentClassification.code')" prop="code">
        <el-input
          v-model="queryParams.code"
          :placeholder="t('EquipmentManagement.EquipmentClassification.placeholderCode')"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.EquipmentClassification.name')" prop="name">
        <el-input
          v-model="queryParams.name"
          :placeholder="t('EquipmentManagement.EquipmentClassification.placeholderName')"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.EquipmentClassification.createTime')" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          :start-placeholder="t('common.startTimeText')"
          :end-placeholder="t('common.endTimeText')"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-220px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> {{ t('common.query') }}</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> {{ t('common.reset') }}</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
        >
          <Icon icon="ep:plus" class="mr-5px" /> {{ t('action.add') }}
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['mes:device-type:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> {{ t('action.export') }}
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table
      v-loading="loading"
      :data="list"
      :stripe="true"
      :show-overflow-tooltip="true"
      row-key="id"
      default-expand-all
      :tree-props="{ children: 'children' }"
    >
      <!-- <el-table-column :label="t('EquipmentManagement.EquipmentClassification.id')" align="center" prop="id" /> -->
      <el-table-column :label="t('EquipmentManagement.EquipmentClassification.code')" align="center" prop="code" />
      <el-table-column :label="t('EquipmentManagement.EquipmentClassification.name')" align="center" prop="name" />
      <el-table-column :label="t('EquipmentManagement.EquipmentClassification.remark')" align="center" prop="remark" />
      <el-table-column :label="t('EquipmentManagement.EquipmentClassification.sort')" align="center" prop="sort" />
      <el-table-column
        :label="t('EquipmentManagement.EquipmentClassification.createTime')"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column :label="t('EquipmentManagement.EquipmentClassification.operate')" align="center" min-width="120px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('create', undefined, scope.row)"
          >
            {{ t('EquipmentManagement.EquipmentClassification.add') }}
          </el-button>
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id, scope.row)"
          >
            {{ t('EquipmentManagement.EquipmentClassification.edit') }}
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
          >
            {{ t('EquipmentManagement.EquipmentClassification.delete') }}
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      v-if="showPagination"
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <DeviceTypeForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { DeviceTypeApi, DeviceTypeTreeVO } from '@/api/mes/devicetype'
import DeviceTypeForm from './DeviceTypeForm.vue'

/** 设备类型 列表 */
defineOptions({ name: 'DeviceType' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<DeviceTypeTreeVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const showPagination = ref(true)
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  code: undefined,
  name: undefined,
  createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const [createStartTime, createEndTime] = Array.isArray(queryParams.createTime)
      ? queryParams.createTime
      : []
    const data = await DeviceTypeApi.getDeviceTypeTree({
      pageNo: queryParams.pageNo,
      pageSize: queryParams.pageSize,
      code: queryParams.code,
      name: queryParams.name,
      createStartTime: createStartTime || undefined,
      createEndTime: createEndTime || undefined
    })

    if (Array.isArray(data)) {
      list.value = data
      total.value = data.length
      showPagination.value = false
      return
    }

    list.value = data.list
    total.value = data.total
    showPagination.value = true
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number, parentRow?: DeviceTypeTreeVO) => {
  formRef.value.open(type, id, parentRow)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await DeviceTypeApi.deleteDeviceType(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await DeviceTypeApi.exportDeviceType(queryParams)
    download.excel(data, '设备类型.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
